From 818004ff663e718071d056087ee30cbab31c173f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 04 2020 03:01:33 +0000
Subject: [PATCH 1254/2232] Merge pull request #414 from dtolnay/sort


Point out every field involved in the cycle
---

diff --git a/syntax/toposort.rs b/syntax/toposort.rs
index 7c210f2..876f9ad 100644
--- a/syntax/toposort.rs
+++ b/syntax/toposort.rs
@@ -34,16 +34,18 @@ fn visit<'a>(
             entry.insert(Mark::Visiting);
         }
     }
+    let mut result = Ok(());
     for field in &strct.fields {
         if let Type::Ident(ident) = &field.ty {
             if let Some(inner) = types.structs.get(&ident.rust) {
                 if visit(cx, inner, sorted, marks, types).is_err() {
                     cx.error(field, "unsupported cyclic data structure");
+                    result = Err(());
                 }
             }
         }
     }
     marks.insert(strct, Mark::Visited);
     sorted.push(strct);
-    Ok(())
+    result
 }
diff --git a/tests/ui/struct_cycle.rs b/tests/ui/struct_cycle.rs
index be5f553..e74c2b1 100644
--- a/tests/ui/struct_cycle.rs
+++ b/tests/ui/struct_cycle.rs
@@ -25,6 +25,10 @@ mod ffi {
     struct Node5 {
         node2: Node2,
     }
+
+    struct Node6 {
+        node2: Node2,
+    }
 }
 
 fn main() {}
diff --git a/tests/ui/struct_cycle.stderr b/tests/ui/struct_cycle.stderr
index 7a64e29..49bcb5f 100644
--- a/tests/ui/struct_cycle.stderr
+++ b/tests/ui/struct_cycle.stderr
@@ -3,3 +3,21 @@ error: unsupported cyclic data structure
    |
 26 |         node2: Node2,
    |         ^^^^^^^^^^^^
+
+error: unsupported cyclic data structure
+  --> $DIR/struct_cycle.rs:22:9
+   |
+22 |         node5: Node5,
+   |         ^^^^^^^^^^^^
+
+error: unsupported cyclic data structure
+  --> $DIR/struct_cycle.rs:13:9
+   |
+13 |         node4: Node4,
+   |         ^^^^^^^^^^^^
+
+error: unsupported cyclic data structure
+ --> $DIR/struct_cycle.rs:8:9
+  |
+8 |         node2: Node2,
+  |         ^^^^^^^^^^^^

